#!/usr/bin/env python

"""
This test attempts to record the usage of 'D' in 'test_conditional' since 'f'
and 'g' are both normally required, and only 'D' provides these attributes.
Classes 'C' and 'E' should lose their methods, even 'E.f'.
"""

class C:
    def f(self): # unused
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

class E:
    def f(self): # unused
        return 4

    def h(self): # unused
        return 5

def test_conditional(obj):
                            # obj: f, g; f
    if obj.f():
        obj.g()
    return 2

c = C()
d = D()
e = E()
result1_2 = test_conditional(d)

# vim: tabstop=4 expandtab shiftwidth=4
